/*
 * * Copyright (C) 2007 Joni Valtanen <jvaltane@kapsi.fi>
 *
 * This program is free software; you can redistribute it and/or
 * modify
 * it under the terms of the GNU General Public License as published
 * by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307,
 * USA.
 */


#ifndef _REMOTE_UDP_H_
#define _REMOTE_UDP_H_

/* Network stuff */
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>

#include <glib-object.h>
#include <glib/gtypes.h>

G_BEGIN_DECLS

#define REMOTE_TYPE_UDP (remote_udp_get_type ())
#define REMOTE_UDP(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), REMOTE_TYPE_UDP, RemoteUdp))
#define REMOTE_IS_UDP(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), REMOTE_TYPE_UDP))
#define REMOTE_UDP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), REMOTE_TYPE_UDP, RemoteUdpClass))
#define REMOTE_IS_UDP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), REMOTE_TYPE_UDP))
#define REMOTE_UDP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), REMOTE_TYPE_UDP, RemoteUdpClass))

typedef struct _RemoteUdp RemoteUdp;
typedef struct _RemoteUdpClass RemoteUdpClass;

struct _RemoteUdpClass
{
  GObjectClass parent;
};

struct _RemoteUdp
{
  GObject parent;

  /* to set from outerside */
  guint port;
  gchar *host;

  /* very private */
  struct sockaddr_in addr;
  int udp_socket;
};

RemoteUdp   *remote_udp_new (void);
GType  remote_udp_get_type (void);

gint remote_udp_send_data (RemoteUdp *self, gpointer data);

#endif
